/**
* @par Copyright (C): 2010-2019, Shenzhen Yahboom Tech
* @file         ServoControlColor.c
* @author       Danny
* @version      V1.0
* @date         2017.08.16
* @brief        ת߲̽յ
* @details
* @par History  ˵
*
*/
#include "STC12C5A60S2.H"

#define ON 1     //ʹLED
#define OFF 0    //ֹLED

//RGB߲ʵ
sbit LED_R = P4^6;	//LED_RSTC12C5A60S2EAP4^6ܽ
sbit LED_G = P4^5;  //LED_GSTC12C5A60S2ALEP4^5ܽ
sbit LED_B = P4^4;	//LED_BSTC12C5A60S2PSENP4^4ܽ

//
sbit ServoPin=P0^5;

//嶨ʱͽǶֵ
unsigned int count = 0;
unsigned char myangle = 0;

//
void color_light(int pos);
void color_led(int v_iRed, int v_iGreen, int v_iBlue);
void servo_control_color();

/**
* Function       delay
* @author        Danny
* @date          2017.08.16
* @brief         ʱ
* @param         xmsʱʱ䣨ms
* @retval        void
* @par History   
*/
 void delay(unsigned int xms)				
{
	unsigned int i,j;
	for(i=xms;i>0;i--)		     
	    for(j=900;j>0;j--);
}

/**
* Function       servo_control_color
* @author        Danny
* @date          2017.08.16
* @brief         0-180ת,Ȼ1800ת
*                ͬʱ180ȽǷΪ7ʾ7ֲͬɫ
* @param[in]     void
* @param[out]    void
* @retval        void
* @par History   
*/
void servo_control_color()
{
    //תλ
    int pos = 0;
    int i = 0;
    for (pos = 1; pos < 180; pos=pos+5)
    {
    	//0ת180,ÿʱ5ms
		for(i=0;i<15;i++)
		{
      		myangle=pos;
	  		delay(5);	
		}
        //תӦĽǶ,жϵغ
		color_light(pos);
	}
	for (pos = 180; pos > 0; pos=pos-5)
    {
    	//180ת0,ÿʱ5ms
		for(i=0;i<15;i++)
		{
    		myangle=pos;
    		delay(5);
		}
    	//תӦĽǶ,жϵغ
   		color_light(pos);
  	}
    return;
}

/**
* Function       color_light
* @author        Danny
* @date          2017.08.16
* @brief         תĽǶӦɫ
* @param[in]     pos תλ
* @param[out]    void
* @retval        void
* @par History   
*/
void color_light(int pos)
{
	//ת150-180ʱ,һɫ
    if (pos > 150)
    {
    	color_led(ON, OFF, OFF);
    }
    //ת125-150ʱ,һɫ
    else if (pos > 125)
    {
    	color_led(OFF, ON, OFF);
    }
    //ת100-125ʱ,һɫ
    else if (pos > 100)
    {
    	color_led(OFF, OFF, ON);
    }
    //ת75-100ʱ,һɫ
    else if (pos > 75)
    {
    	color_led(OFF, ON, ON);	
    }
    //ת50-75ʱ,һɫ
    else if (pos > 50)
    {
    	color_led(ON, ON, OFF);
    }
    //ת25-50ʱ,һɫ
   else if (pos > 25)
    {
    	color_led(ON, OFF, ON);
    }
    //ת0-25ʱ,һɫ
    else if (pos > 0)
    {
    	color_led(ON, ON, ON);	
	}
    else
    {
    	color_led(OFF, OFF, OFF);
	}
}

/**
* Function       color_led
* @author        Danny
* @date          2017.08.16
* @brief         R,G,BɫĲͬγ7ֲͬɫ
* @param[in1]    Red
* @param[in2]    Green
* @param[in3]    Blue
* @retval        void
* @par History   
*/
void color_led(int v_iRed, int v_iGreen, int v_iBlue)
{
	//ɫLED
  	v_iRed == ON ? (LED_R = 1): (LED_R = 0);
 
  	//ɫLED
  	v_iGreen == ON ? (LED_G = 1): (LED_G = 0);
  
  	//ɫLED
  	v_iBlue == ON ? (LED_B = 1): (LED_B = 0);
  
}

/**
* Function       timer1
* @author        Danny
* @date          2017.08.16
* @brief         TIMER1жϷӺPWMźţƶ
* @param[in]     void
* @param[out]    void
* @retval        void
* @par History   
*/
void timer1() interrupt 3  
{
	int PulseWidth;  
	TH1=0XFF;            //100usʱװֵ
	TL1=0XA4;
	count++;
            	              //
	PulseWidth = ((myangle*11)+500)/100 ; //Ϊ˽0-180תΪӦֵ
	if(count == PulseWidth)
	{
    	ServoPin=0;           //ӿڵƽõ
	}	           
	if(count == 190)		  //190ΪյԻõһֵ
    {
    	count = 0;
        ServoPin=1;           //ӿڵƽø
	}
}

/**
* Function       main
* @author        Danny
* @date          2017.08.16
* @brief         ʱ0.5ŵö߲ʵƳ
* @param[in]     void
* @retval        void
* @par History   
*/
void main()
{ 
	unsigned char i =0;	
	TMOD=0X10;  //ʱʽ1
    TH1=0XFF;   //100usʱװֵ
    TL1=0XA4;
	TR1=1;		//T1
    ET1=1;		//T1ж
	EA =1;	    //ж
	
	//P4ΪͨIOʹ
    P4SW |= (1<<4);
    P4SW |= (1<<5);
    P4SW |= (1<<6);
	
	//P4Ϊǿģʽ
	P4M1 &= ~(1<<4); 
	P4M1 &= ~(1<<5);
	P4M1 &= ~(1<<6);

   	P4M0 |= (1<<4);
   	P4M0 |= (1<<5);
   	P4M0 |= (1<<6); 

   //ųʼΪߵƽ
  	ServoPin=1;
   
   //ʼλǰ 
    for(i = 0; i<15;i++)
    {
		myangle = 90; 
		delay(20);
	}

    while(1)
	{   
     	//ö߲ʵƳ
		servo_control_color();
	}
}
